# This is FindMyFood-NodeServer README

## Commands to hit server with REST calls

## Users

###Create a new user (Require: username, password, location, email, birthday, gender):
```
curl -i -X POST -H 'Content-Type: application/json' -d '{"username":"maximilian", "password":"max123", "location":{"long":"123","lat":"345"}, "email":"max@gmail.com", "birthday":"1905","gender":"male"}' http://findmyfood.jit.su/users/createUser
```

###Login User (Require: username or email and password):
```
curl -i -X POST -H 'Content-Type: application/json' -d '{"username":"maximilian", "password":"max123"}'  http://findmyfood.jit.su/users/loginUser
```

###Delete User (Require: username or email and password):
```
curl -i -X DELETE -H 'Content-Type: application/json' -d '{"username":"maximilian", "password":"max123"}' http://findmyfood.jit.su/users/deleteUser/maximilian
```

###Update User (Require: username and fields to update):
```
curl -i -X PUT -H 'Content-Type: application/json' -d '{"username":"maximilian", "email":"max1@gmail.com"}' http://findmyfood.jit.su/users/updateUser

curl -i -X PUT -H 'Content-Type: application/json' -d '{"username":"maximilian", "preferences":{"foodKind":"ACA VA EL ARREGLO"}}' http://findmyfood.jit.su/users/updateUser

curl -i -X PUT -H 'Content-Type: application/json' -d '{"username":"maximilian", "gender":"male"}' http://findmyfood.jit.su/users/updateUser

curl -i -X PUT -H 'Content-Type: application/json' -d '{"username":"maximilian", "location":{"long":"123","lat":"321"}}' http://findmyfood.jit.su/users/updateUser
```

###Find User By Id (Require: user _id):
```
curl -i -X GET -H 'Content-Type: application/json' -d '{"_id":"519a7d7d6d6948722f000001"}' http://findmyfood.jit.su/users/findUserById
```
###Find User By Username (Require: username):
```
curl -i -X GET -H 'Content-Type: application/json' -d '{"username":"maximilian"}' http://findmyfood.jit.su/users/findUserByUsername
```

## Places

###Create place (Require: placeName):
```
curl -i -X POST -H 'Content-Type: application/json' -d '{"placeName":"restaurante00" , "ranking": 0}' http://findmyfood.jit.su/places/createPlace
```

###Create branch (Require: placeName, branchName, location({"long":"12","lat":"34"})):
```
curl -i -X POST -H 'Content-Type: application/json' -d '{"placeName":"restaurante1","branchName":"brres1","location":{"lat":"23","long":"45"}}' http://findmyfood.jit.su/places/createBranch
```

###Rank place (Require: placeName, value):
```
curl -i -X PUT -H 'Content-Type: application/json' -d '{"placeName":"restaurante00","ranking":5}' http://findmyfood.jit.su/places/rankPlace/restaurante00
```
###find data of the place
```
curl -i -X GET -H 'Content-Type: application/json' -d '{"placeName":"restaurante03","_id":"518aad99518fb75b6e000001"}' http://findmyfood.jit.su/places/getDataByPlaceId/518aad99518fb75b6e000001
```
###find data of the branch
```
curl -i -X GET -H 'Content-Type: application/json' -d '{"placeName":"restaurante1","_id":"519ae95e235b464d4b000001"}' http://findmyfood.jit.su/places/getDataByBranchId/519ae95e235b464d4b000001

```

###Find branch by location
```
curl -i -X GET -H 'Content-Type: application/json' http://findmyfood.jit.su/places/getBranchesByLocation/34/43/100

```

## Chekins

###Create checkIn (Require: username, placeName, branchName, date):
```
curl -i -X POST -H 'Content-Type: application/json' -d '{"username":"maximilian", "placeName":"restaurante00" , "branchName":"elf", "date":"06 May, 2013 09:15:00" }' http://findmyfood.jit.su/checkIn/createcheckIn
```
###Find checkIn By Id (Require: _id username, placeName, branchName, date):
```
curl -i -X GET -H 'Content-Type: application/json' -d '{"_id":"519ae21161d9352160000001" }' http://findmyfood.jit.su/checkIn/findcheckInById/519ae21161d9352160000001

```
###Find checkIn By username (Require: username):
```
curl -i -X GET -H 'Content-Type: application/json' -d '{"username":"maximilian" }' http://findmyfood.jit.su/checkIn/findcheckIn/maximilian
```

#User Object
```
var user = {
    _id:'n3nc8cn98nc8nc83',
    name:'Daniel Camilo Daza Diaz',
    username:'dazuku',
    password:'1234',
    gender:'male',
    typeUser:'Regular',
    profilePicture:'localhost/images/thumbnail.png',
    description:'soy re basilado',
    birthDay: new Date('Aug 22, 1991'),
    dateRegistration: new Date(),
    checkIns:[125627bhv6u98,827817928bsyyg9],      
    list: [],
    friends : [
            {
                    friendId:"in5fn85n899n9d993d",
                    dateMakeFriendly: new Date()
            },
            {
                    friendId:"in5fn85n899ctjctkv5n9d993d",
                    dateMakeFriendly: new Date()
            }
    ],
    preferences: {
            foodKind:['chinese':true, 'Colombian':true, 'Thai':false],
            radius: 5
    },
    networks:[
            {name:'facebook', uniqueID:'123456', havePermitions:true},
            {name:'twitter', uniqueID:'123456', havePermitions:true}
    ],
    location:'Bogota, COL',
    email: 'dazuku.rulo@gmail.com'
};
```

#Place Object
```
var place = {
    name:'El Corral',
    placename:'elcorral',
    logo:'localhost/images/thumbnail.png',
    branches:[2323eun4urbu4, 2y37y723h7hd72h4],
    dishes:['jnsjsnjn28273872','2988hd3h7h8h9'],
    premium:true,
    typesOfFood:['Thai', 'Chinese', 'Colombian'],
    ranking:5,
    characteristics:{
            homes:true,
            drive_in:true,
            internet:true,
            breakfast:true,
            vegetarian_food:true
    },
    comment:'hello world',
    popularity:4.5
};
```

#Check-In Object
```
var checkIns = {
    date:'13 de septiembre de 2013',
    placeID:'nu7b3bubbbu3',
    branchID:'njnjn7y737279u29829s',
    userID:'neduhe737hd73gd73ghd7',
    placename:'elcorral',
    branchname:'colina',
    username:'dazuku',
    dishes:[
            {
                    name:'Hamburguesa',
                    photo:'localhost/images/thumbnail.png',
                    comment:'Sabrosa!',
                    ranking:5
            },
            {
                    name:'Hamburguesa de pollo',
                    photo:'localhost/images/thumbnail.png',
                    comment:'Sabrosa!',
                    ranking:5
            }
    ],
    comment:'hello world',
    photo:'/img/checkin.png'
};
```

#Branch Object
```
{
        _id:123457,
        location:{point:{lng:'23', lat:'35'}},
        name:'Santafe',
        photos:[{date:1234567890, id:'1234567'}],
        dishes:['jnsjsnjn28273872','2988hd3h7h8h9']
}
```

/***************** TO-DO IN PLACES *****************/
/*
// Update place
FMFServer.put('/places/updatePlace/:placeName',placesManager.updatePlace);

// Update branch
FMFServer.put('/places/updateBranch/:placeName/:branchName',placesManager.updateBranch);

// Find place
FMFServer.get('/places/findPlace/',placesManager.findPlace);

//create Dish
FMFServer.post('/places/:placeName/dishName',placesManager.createDish);

// Rank Dish
FMFServer.post('/places/:placeName/:dishID',placesManager.rankDish);

//Find Dish
FMFServer.post('/places/dishName',placesManager.findDish);