var  databaseManager  =  require ( './databaseManager' );

/**
*@public this method is a express callback  that adds a checkIn in dbs
*@param request {readable node.js stream} - Arrive with a checkIn{object}
*@param response {writable node.js stream} - Return a menssaje, code and checkIn{object} 
*@requires checkIn fields: username, placeName, branchName, date.
**/

var createCheckIn = function(req,res){
	var chekInFromClient = req.body,
	responseToClient = {};
	if(chekInFromClient.hasOwnProperty('username') && chekInFromClient.hasOwnProperty('placeName') && chekInFromClient.hasOwnProperty('branchName')  && chekInFromClient.hasOwnProperty('date')){
		if(chekInFromClient.username.length > 0 && chekInFromClient.placeName.length > 0 && chekInFromClient.branchName.length > 0  && chekInFromClient.date.length > 0 ){
			databaseManager.createCheckIn(chekInFromClient,
				function(data){
					if(data.state == 200){
						responseToClient.meta = {"status":200,"msg":"ok"};
                        responseToClient.response = chekInFromClient;
                        res.send(responseToClient);
					}else{
						responseToClient.meta = {"status":400,"msg":"err"};
                        responseToClient.response = {message:"Check in failed"};
                        res.send(responseToClient);
                    }
                },function(data){res.send(data);});
		}else{
			responseToClient.meta = {"status":400,"msg":"err"};
			responseToClient.response = {message:"Complete the required fields"};//especificar cuales campos
			res.send(responseToClient);
		}
	}else{
		responseToClient.meta = {"status":400,"msg":"err"};
        responseToClient.response = {message:"Complete the required fields"};//especificar cuales campos
        res.send(responseToClient);
	}
};

/**
*@public This method is a express callback that find checkIn by username in dbs
*@param {readable node.js stream} request - Arrive with a find{object}
*@param {writable node.js stream} response - Return a status, msg, menssaje, and checkIn{object} 
*@requires find fields: username.
**/

var findCheckIn = function(req,res){
	var findChekInFromClient = req.params,
	responseToClient = {};
	if(findChekInFromClient.hasOwnProperty('username')){
		if(findChekInFromClient.username.length > 0 ){
			databaseManager.findCheckIn("username",findChekInFromClient.username,[],
				function(data){
					if(data.state == 200){
						responseToClient.meta = {"status":200,"msg":"ok"};
                        responseToClient.response = data;
                        res.send(responseToClient);
					}else{
						responseToClient.meta = {"status":400,"msg":"err"};
                        responseToClient.response = {message:"Search of Check in failed"};
                        res.send(responseToClient);
					}
				},function(data){res.send(data);});
		}else{
			responseToClient.meta = {"status":400,"msg":"err"};
			responseToClient.response = {message:"Complete the required fields"};//especificar cuales campos
			res.send(responseToClient);
		}
	}else{
		responseToClient.meta = {"status":400,"msg":"err"};
        responseToClient.response = {message:"Complete the required fields"};//especificar cuales campos
        res.send(responseToClient);
	}
};

/**
*@public This method is a express callback that find checkIn by checkIn Id in dbs
*@param {readable node.js stream} request - Arrive with a findById{object}
*@param {writable node.js stream} response - Return a status, msg, menssaje, and checkIn{object} 
*@requires findById fields: _id.
**/

var findCheckInById = function(req,res){
	var findChekInFromClient = req.params,
	responseToClient = {};
	if(findChekInFromClient.hasOwnProperty('_id')){
		if(findChekInFromClient._id.length > 0 ){
			databaseManager.findCheckIn("_id",findChekInFromClient._id,[],
				function(data){
					if(data.state == 200){
						responseToClient.meta = {"status":200,"msg":"ok"};
                        responseToClient.response = data;
                        res.send(responseToClient);
					}else{
						responseToClient.meta = {"status":400,"msg":"err"};
                        responseToClient.response = {message:"Search of Check in failed"};
                        res.send(responseToClient);
					}
				},function(data){res.send(data);});
		}else{
			responseToClient.meta = {"status":400,"msg":"err"};
			responseToClient.response = {message:"Complete the required fields"};//especificar cuales campos
			res.send(responseToClient);
		}
	}else{
		responseToClient.meta = {"status":400,"msg":"err"};
        responseToClient.response = {message:"Complete the required fields"};//especificar cuales campos
        res.send(responseToClient);
	}
};

/**
*@public This method is a express callback that deleted a checkIn in dbs
*@param {readable node.js stream} request - Arrive with a delete{object}
*@param {writable node.js stream} response - Return a status, msg, menssaje.
**/

var deleteCheckIn = function(req,res){
        res.send("method in process");
};

/**
*@public This method is a express callback that update checkIN in dbs if have a change new
*@param {readable node.js stream} request - Arrive with a update {object}
*@param {writable node.js stream} response - Return a status, msg, menssaje, and checkIn{object} 
**/

var updateCheckIn = function(req,res){
        res.send("method in process");
};

exports.createCheckIn = createCheckIn;
exports.deleteCheckIn = deleteCheckIn;
exports.updateCheckIn = updateCheckIn;
exports.findCheckIn = findCheckIn;
exports.findCheckInById = findCheckInById;