var Db = require('mongodb').Db,
        Server = require('mongodb').Server,
        host = 'dharma.mongohq.com',
        port = 10089,
        isConnected = false,
        dbName = 'Find-My-Food',
        usersCollection = {},
        placesCollection = {},
        checkInsCollection = {},
        branchesCollection = {},
        db = {},
        ObjectID = require('mongodb').ObjectID;

// Creating the database
db = new Db(dbName, new Server(host, port), {safe:false});

db.open(function(error, dat){
        isConnected = error ? false : true;
        console.log((error ? ("error " + error) : ("Connect to " + dbName + " successfull")));
        if (isConnected) {
                db.authenticate('FMF_debug', 'Rk1GRGlAejE5OTE=', function (err, replies) {
                        console.log((err ? ("error " + err) : ("Connect to " + dbName + " succesfull")));
                        if (err) {
                                console.log("error " + err);
                        } else {
                                // Creating Collections of users and saving this collection into usersCollection
                                db.createCollection('users', function(err, col) {
                                        usersCollection = col;
                                });
                                db.createCollection('places', function(err, col) {
                                        placesCollection = col;
                                });
                                db.createCollection('checkIns', function(err, col) {
                                        checkInsCollection = col;
                                });
                                db.createCollection('branches', function(err, col) {
                                        branchesCollection = col;
                                });
                        }
                });
        }
});

/*
var Utils = function(){
        var validateEmail = function(email) {
                var re = /^(([^<>()[\]\\.,;:\s@\"]+(\.[^<>()[\]\\.,;:\s@\"]+)*)|(\".+\"))
                @((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
                return re.test(email);
        };

        return {validateEmail:validateEmail};
}();
*/

/**
 * @public This method creates one user in the database.
 * @param {Object} user - JSON object that represented a user and he needs the properties username and password, like minimum.
 * @param {Function} succesfullCallback - Callback run when the database can create the user.
 * @param {Function} errorCallback - Callback run when the database cannot create the user.
**/
var createUser = function(user, succesfullCallback, errorCallback){

        /* USER OBJECT
        var params = {
                _id:'n3nc8cn98nc8nc83',
                name:'Daniel Camilo Daza Diaz',
                username:'dazuku',
                password:'1234',
                gender:'male',
                typeUser:'Regular',
                profilePicture:'localhost/images/thumbnail.png',
                description:'soy re basilado',
                dateBirth: new Date('Aug 22, 1991'),
                dateRegistration: new Date(),
                checkIns:[
                        {
                                date: new Date(),
                                dishes:[
                                        {
                                                idDish: "432nri4nf5nfini",
                                                dishPhotos: 
                                                ['localhost/images/thumbnail.png', 'localhost/images/thumbnail.png'],
                                                comment: 'Delicioso',
                                                ranking: 5
                                        },
                                        {
                                                idDish: "432nhuhri4nf5nfini",
                                                dishPhotos: 
                                                ['localhost/images/thumbnail.png', 'localhost/images/thumbnail.png'],
                                                comment: 'Delicioso',
                                                ranking: 5
                                        }
                                ],
                                branch: "u4nrunf848fn89nd84",
                                comment: 'Muy buen sitio',
                                branchPhotos: ['localhost/images/thumbnail.png', 'localhost/images/thumbnail.png']
                        }       
                ],
                list: [],
                friends : [
                        {
                                friendId:"in5fn85n899n9d993d",
                                dateMakeFriendly: new Date()
                        },
                        {
                                friendId:"in5fn85n899ctjctkv5n9d993d",
                                dateMakeFriendly: new Date()
                        }
                ],
                preferences: {
                        foodKind:['chinese', 'Colombian'],
                        radius: 5
                },
                networks:[
                        {name:'facebook', uniqueID:'123456', havePermitions:true},
                        {name:'twitter', uniqueID:'123456', havePermitions:true}
                ],
                location:'Bogota, COL',
                mail: 'dazuku.rulo@gmail.com'
        };
        USER OBJECT */

        var params = {};

        if(isConnected && user.hasOwnProperty('username') && user.hasOwnProperty('password')) {
                usersCollection.insert(user, function(err, inserted) {
                        if (err) {
                                params.response = false,
                                params.state = 400,
                                params.message = err;
                                errorCallback(params);
                        } else {
                                params.response = true,
                                params.state = 200,
                                params.message = "The user was inserted in the database";
                                params.result = inserted;
                                succesfullCallback(params);
                        }
                });
        } else {
                params.response = false,
                params.state = 400,
                params.message = "The database is not initialiate";
                errorCallback(params);
        }
};

/**
 * @public This method find user in the database.
 * @param {String} field - A name of the field to find.
 * @param {String} content - An Array of Strings who has the content to find.
 * @param {Array} filters - An Array of Strings who has the fields to get, if send the array empty 
                                get all the fields of documents.
 * @param {Function} succesfullCallback - When the database have found the user.
 * @param {Function} errorCallback - When the database have not found the user.
**/
var findUser = function(field, content, filters, succesfullCallback, errorCallback){

        var contents = [content];
        findUsers(field, contents, filters, succesfullCallback, errorCallback);
};

/**
 * @public This method find user in the database.
 * @param {String} field - A name of the field to find.
 * @param {Array} contents - An Array of Strings who has the content to find.
 * @param {Array} filters - An Array of Strings who has the fields to get, if send the array 
                                empty get all the fields of documents.
 * @param {Function} succesfullCallback - When the database have found the users.
 * @param {Function} errorCallback - When the database have not found the users.
**/
var findUsers = function(field, contents, filters, succesfullCallback, errorCallback){

        var params = {},
                query = {},
                fieldsFilters = {},
                isId = false;

        if(field === '_id') {
                isId = true;
                for(var i in contents) {
                        contents[i] = new ObjectID(contents[i]);
                }
        }
        query[field] = {$in:contents};
        fieldsFilters = filters.length !== 0 ? {fields:filters} : {};

        if(isConnected) {
                usersCollection.find(query, fieldsFilters).toArray(function(err, docs){
                        if(err) {
                                params.response = false,
                                params.state = 400,
                                params.message = err;
                                errorCallback(params);
                        } else {
                                params.response = true,
                                params.state = 200;
                                if (docs.length === 0) {
                                        params.state = 300;
                                        params.message = "The user was not found";
                                        params.user = docs[0];
                                } else if(docs.length < 2) {
                                        params.message = "The user was found";
                                        params.user = docs[0];
                                } else {
                                        params.message = "The users was found";
                                        params.users = docs;
                                }
                                succesfullCallback(params);
                        }
                });
        } else {
                params.response = false,
                params.state = 400,
                params.message = "The database is not initialiate";
                errorCallback(params);
        }
};

/**
 * @public This method delete a users in the database.
 * @param {Array} usernames - An Array of Strings who has the usernames. 
 * @param {Function} succesfullCallback - When the database can delete the users.
 * @param {Function} errorCallback - When the database cannot delete the users.
**/
var deleteUsers = function(usernames, succesfullCallback, errorCallback){

        var param = {};

        if(isConnected) {
                findUsers(
                        'username',
                        usernames,
                        [],
                        function(params) {
                                var query = {};
                                if (params.hasOwnProperty('user')) {
                                        query = {username: params.user.username};
                                        usersCollection.remove(query);
                                } else if(params.hasOwnProperty('users')) {
                                        for (var i in params.users) {
                                                query = {username: params.users[i].username};
                                                usersCollection.remove(query);
                                        }
                                }
                                param.response = true,
                                param.state = 200;
                                param.message = "The user(s) was removed for database";
                                param.result = params.result;
                                succesfullCallback(param);
                        },
                        function(params) {
                                errorCallback(params);
                        });
        } else {
                params.response = false,
                params.state = 400,
                params.message = "The database is not initialiate";
                errorCallback(params);
        }
};

/**
 * @public This method delete a users in the database.
 * @param {String} username - The username of the user.
 * @param {Function} succesfullCallback - When the database can delete the user(s).
 * @param {Function} errorCallback - When the database cannot delete the user(s).
**/
var deleteUser = function(username, succesfullCallback, errorCallback){

        var usernames = [username];
        deleteUsers(usernames, succesfullCallback, errorCallback);
};

/**
 * @public This method update a users in the database.
 * @param {String} username - The username of the user.
 * @param {Object} user - The parameters to be edited/added.
 * @param {Function} succesfullCallback - When the database can update the user(s).
 * @param {Function} errorCallback - When the database cannot update the user(s).
**/
var updateUser = function(username, user, succesfullCallback, errorCallback){

        var params = {};
        if(isConnected) {
                usersCollection.update({username:username}, user, true, function(err, updated) {
                        if (err) {
                                params.response = false,
                                params.state = 400,
                                params.message = err;
                                errorCallback(params);
                        } else {
                                params.response = true,
                                params.state = 200,
                                params.message = "The user was updated in the database";
                                params.result = updated;
                                succesfullCallback(params);
                        }
                });
        } else {
                params.response = false,
                params.state = 400,
                params.message = "The database is not initialiate";
                errorCallback(params);
        }
};

/**
 * @public This method update a field of a users in the database.
 * @param {String} username - The username of the user.
 * @param {String} field - The name of the field to be updated.
 * @param {Array, String, Object, Number} Value - The parameters to be edited/added.
 * @param {Function} succesfullCallback - When the database can update the user(s).
 * @param {Function} errorCallback - When the database cannot update the user(s).
**/
var updateFieldOfUser = function(username, field, value, succesfullCallback, errorCallback){

        var params = {};
        var updatedObject = {};
        if(isConnected) {
                updatedObject[field] = value;
                usersCollection.update(
                        {username:username}, //query
                        {$set:updatedObject}, //Update
                        false, //Upsert
                        function(err, updated) {
                        if (err) {
                                params.response = false,
                                params.state = 400,
                                params.message = err;
                                errorCallback(params);
                        } else {
                                params.response = true,
                                params.state = 200,
                                params.message = "The field " + field + " of " + username + " was updated in the database";
                                params.result = updated;
                                succesfullCallback(params);
                        }
                });
        } else {
                params.response = false,
                params.state = 400,
                params.message = "The database is not initialiate";
                errorCallback(params);
        }
};

/**
 * @public This method update a name of a user in the database.
 * @param {String} username - The username of the user.
 * @param {String} name - The name to be updated.
 * @param {Function} succesfullCallback - When the database can update the user(s).
 * @param {Function} errorCallback - When the database cannot update the user(s).
**/
var updateName = function(username, name, succesfullCallback, errorCallback) {
        updateFieldOfUser(username, 'name', name, succesfullCallback, errorCallback);
};

/**
 * @public This method update a description of a user in the database.
 * @param {String} username - The username of the user.
 * @param {String} description - The description to be updated.
 * @param {Function} succesfullCallback - When the database can update the user(s).
 * @param {Function} errorCallback - When the database cannot update the user(s).
**/
var updateDescription = function(username, description, succesfullCallback, errorCallback) {
        updateFieldOfUser(username, 'description', description, succesfullCallback, errorCallback);
};

/**
 * @public This method update a gender of a user in the database.
 * @param {String} username - The username of the user.
 * @param {String} gender - The gender to be updated.
 * @param {Function} succesfullCallback - When the database can update the user(s).
 * @param {Function} errorCallback - When the database cannot update the user(s).
**/
var updateGender = function(username, gender, succesfullCallback, errorCallback) {
        updateFieldOfUser(username, 'gender', gender, succesfullCallback, errorCallback);
};

/**
 * @public This method update a location of a user in the database.
 * @param {String} username - The username of the user.
 * @param {String} location - The location to be updated.
 * @param {Function} succesfullCallback - When the database can update the user(s).
 * @param {Function} errorCallback - When the database cannot update the user(s).
**/
var updateLocation = function(username, location, succesfullCallback, errorCallback) {
        updateFieldOfUser(username, 'location', location, succesfullCallback, errorCallback);
};

/**
 * @public This method update a mail of a user in the database.
 * @param {String} username - The username of the user.
 * @param {String} mail - The mail to be updated.
 * @param {Function} succesfullCallback - When the database can update the user(s).
 * @param {Function} errorCallback - When the database cannot update the user(s).
**/
var updateMail = function(username, email, succesfullCallback, errorCallback) {
        updateFieldOfUser(username, 'email', email, succesfullCallback, errorCallback);
};

/**
 * @public This method update a password of a user in the database.
 * @param {String} username - The username of the user.
 * @param {String} password - The password to be updated.
 * @param {Function} succesfullCallback - When the database can update the user(s).
 * @param {Function} errorCallback - When the database cannot update the user(s).
**/
var updatePassword = function(username, password, succesfullCallback, errorCallback) {
        updateFieldOfUser(username, 'password', password, succesfullCallback, errorCallback);
};

/**
 * @public This method update a profile picture of a user in the database.
 * @param {String} username - The username of the user.
 * @param {String} profilePicture - The profile picture to be updated.
 * @param {Function} succesfullCallback - When the database can update the user(s).
 * @param {Function} errorCallback - When the database cannot update the user(s).
**/
var updateProfilePicture = function(username, profilePicture, succesfullCallback, errorCallback) {
        updateFieldOfUser(username, 'profilePicture', profilePicture, succesfullCallback, errorCallback);
};

/**
 * @public This method update a type user of a user in the database.
 * @param {String} username - The username of the user.
 * @param {String} typeUser - The type user to be updated.
 * @param {Function} succesfullCallback - When the database can update the user(s).
 * @param {Function} errorCallback - When the database cannot update the user(s).
**/
var updateTypeUser = function(username, typeUser, succesfullCallback, errorCallback) {
        updateFieldOfUser(username, 'typeUser', typeUser, succesfullCallback, errorCallback);
};

/**
 * @public This method update a username of a user in the database.
 * @param {String} username - The username of the user.
 * @param {String} value - The username to be updated.
 * @param {Function} succesfullCallback - When the database can update the user(s).
 * @param {Function} errorCallback - When the database cannot update the user(s).
**/
var updateUsername = function(username, value, succesfullCallback, errorCallback) {
        updateFieldOfUser(username, 'username', value, succesfullCallback, errorCallback);
};

/**
 * @public This method update a preferences of a user in the database.
 * @param {String} username - The username of the user.
 * @param {String} preferences - The preferences to be updated.
 * @param {Function} succesfullCallback - When the database can update the user(s).
 * @param {Function} errorCallback - When the database cannot update the user(s).
**/
var updatePreferences = function(preferences, value, succesfullCallback, errorCallback) {
        updateFieldOfUser(preferences, 'preferences', value, succesfullCallback, errorCallback);
};

/**
 * @public This method creates one place in the database
 * @param {Object} place - The name of the place.
 * @param {Function} succesfullCallback - When the database can create the place.
 * @param {Function} errorCallback - When the database cannot create the place.
**/
var createPlace = function(place, succesfullCallback, errorCallback){

        /* PLACES OBJECT
        var place = {
                name:'El Corral',
                placeName:'elcorral',
                logo:'localhost/images/thumbnail.png',
                branches:[
                        {
                                id:123456,
                                location:{latitude:'23', longitude:'35'},
                                name:'Colina',
                                photos:[{date:1234567890, id:'1234567'}],
                                dishes:['jnsjsnjn28273872','2988hd3h7h8h9']
                        },
                        {
                                id:123457,
                                location:{latitude:'23', longitude:'35'},
                                name:'Santafe',
                                photos:[{date:1234567890, id:'1234567'}],
                                dishes:['jnsjsnjn28273872','2988hd3h7h8h9']
                        }
                ],
                dishes:['jnsjsnjn28273872','2988hd3h7h8h9'],
                premium:true,
                typesOfFood:['Thai', 'Chinese', 'Colombian'],
                ranking:5,
                characteristics:{
                        homes:true,
                        drive_in:true,
                        internet:true,
                        breakfast:true,
                        vegetarian_food:true
                },
                comment:'hello world',
                popularity:4.5
        };
        PLACES OBJECT */

        var params = {};

        if(isConnected /*&& place.hasOwnProperty('name')*/ && place.hasOwnProperty('placeName')) {
                placesCollection.insert(place, function(err, inserted) {
                        if (err) {
                                params.response = false,
                                params.state = 400,
                                params.message = err;
                                errorCallback(params);
                        } else {
                                params.response = true,
                                params.state = 200,
                                params.message = "The place was inserted in the database";
                                params.result = inserted;
                                succesfullCallback(params);
                        }
                });
        } else {
                params.response = false,
                params.state = 400,
                params.message = "The database is not initialiate";
                errorCallback(params);
        }
};

/**
 * @public This method find place in the database.
 * @param {String} field - A name of the field to find.
 * @param {String} content - An Array of Strings who has the content to find.
 * @param {Array} filters - An Array of Strings who has the fields to get, if send the array 
                                empty get all the fields of documents.
 * @param {Function} succesfullCallback - When the database have found the place.
 * @param {Function} errorCallback - When the database have not found the place.
**/
var findPlace = function(field, content, filters, succesfullCallback, errorCallback){

        var contents = [content];
        findPlaces(field, contents, filters, succesfullCallback, errorCallback);
};

/**
 * @public This method find places in the database.
 * @param {String} field - A name of the field to find.
 * @param {String} content - An Array of Strings who has the content to find.
 * @param {Array} filters - An Array of Strings who has the fields to get, if send the array 
                                empty get all the fields of documents.
 * @param {Function} succesfullCallback - When the database have found the place.
 * @param {Function} errorCallback - When the database have not found the place.
**/
var findPlacesWithRegex = function(field, content, filters, succesfullCallback, errorCallback) {
        var regex = new RegExp(content, 'i');
        findPlaces(field, regex, filters, succesfullCallback, errorCallback);
}

/**
 * @public This method find places in the database.
 * @param {String} field - A name of the field to find.
 * @param {Array} contents - An Array of Strings who has the content to find.
 * @param {Array} filters - An Array of Strings who has the fields to get, if send the array 
                                empty get all the fields of documents.
 * @param {Function} succesfullCallback - When the database have found the users.
 * @param {Function} errorCallback - When the database have not found the users.
**/
var findPlaces = function(field, contents, filters, succesfullCallback, errorCallback){

        var params = {},
                query = {},
                fieldsFilters = {},
                isId = false;

        if(field.indexOf('_id') !== -1) {
                isId = true;
                for(var i in contents) {
                        contents[i] = new ObjectID(contents[i]);
                }
        }
        query[field] = {$in:contents};
        fieldsFilters = filters.length !== 0 ? {fields:filters} : {};

        if(isConnected) {
                placesCollection.find(query, fieldsFilters).toArray(function(err, docs){
                        if(err) {
                                params.response = false,
                                params.state = 400,
                                params.message = err;
                                errorCallback(params);
                        } else {
                                params.response = true,
                                params.state = 200;
                                if (docs.length === 0) {
                                        params.state = 300;
                                        params.message = "The place was not found";
                                        params.place = docs;
                                } else if(docs.length < 2) {
                                        params.message = "The place was found";
                                        params.place = docs;
                                } else {
                                        params.message = "The places was found";
                                        params.place = docs;
                                }
                                succesfullCallback(params);
                        }
                });
        } else {
                params.response = false,
                params.state = 400,
                params.message = "The database is not initialiate";
                errorCallback(params);
        }
};

/**
 * @public This method delete a places in the database.
 * @param {Array} placeNames - An Array of Strings who has the placeNames. 
 * @param {Function} succesfullCallback - When the database can delete the places.
 * @param {Function} errorCallback - When the database cannot delete the places.
**/
var deletePlaces = function(placeNames, succesfullCallback, errorCallback){

        var param = {};

        if(isConnected) {
                findPlaces(
                        'placeName',
                        placeNames,
                        [],
                        function(params) {
                                var query = {};
                                if (params.hasOwnProperty('place')) {
                                        query = {placeName: params.place.placeName};
                                        placesCollection.remove(query);
                                } else if(params.hasOwnProperty('places')) {
                                        for (var i in params.place) {
                                                query = {placeName: params.places[i].placeName};
                                                placesCollection.remove(query);
                                        }
                                }
                                param.response = true,
                                param.state = 200;
                                param.message = "The place(s) was removed for database";
                                param.result = params.result;
                                succesfullCallback(param);
                        },
                        function(params) {
                                errorCallback(params);
                        });
        } else {
                params.response = false,
                params.state = 400,
                params.message = "The database is not initialiate";
                errorCallback(params);
        }
};

/**
 * @public This method delete a places in the database.
 * @param {String} placeName - The placeName of the place.
 * @param {Function} succesfullCallback - When the database can delete the place(s).
 * @param {Function} errorCallback - When the database cannot delete the place(s).
**/
var deletePlace = function(placeName, succesfullCallback, errorCallback){

        var placeNames = [placeName];
        deletePlaces(usernames, succesfullCallback, errorCallback);
};

/**
 * @public This method update a places in the database.
 * @param {String} placeName - The placeName of the place.
 * @param {Object} place - The parameters to be edited/added.
 * @param {Function} succesfullCallback - When the database can update the place(s).
 * @param {Function} errorCallback - When the database cannot update the place(s).
**/
var updatePlace = function(placeName, place, succesfullCallback, errorCallback){

        var params = {};
        if(isConnected) {
                placesCollection.update({placeName:placeName}, place, true, function(err, updated) {
                        if (err) {
                                params.response = false,
                                params.state = 400,
                                params.message = err;
                                errorCallback(params);
                        } else {
                                params.response = true,
                                params.state = 200,
                                params.message = "The place was updated in the database";
                                params.result = updated;
                                succesfullCallback(params);
                        }
                });
        } else {
                params.response = false,
                params.state = 400,
                params.message = "The database is not initialiate";
                errorCallback(params);
        }
};

/**
 * @public This method update a field of a places in the database.
 * @param {String} placeName - The placeName of the place.
 * @param {String} field - The name of the field to be updated.
 * @param {Array, String, Object, Number} Value - The parameters to be edited/added.
 * @param {Function} succesfullCallback - When the database can update the place(s).
 * @param {Function} errorCallback - When the database cannot update the place(s).
**/
var updateFieldOfPlace = function(placeName, field, value, succesfullCallback, errorCallback){

        var params = {};
        var updatedObject = {};
        if(isConnected) {
                updatedObject[field] = value;
                placesCollection.update(
                        {placeName:placeName}, //query
                        {$set:updatedObject}, //Update
                        false, //Upsert
                        function(err, updated) {
                        if (err) {
                                params.response = false,
                                params.state = 400,
                                params.message = err;
                                errorCallback(params);
                        } else {
                                params.response = true,
                                params.state = 200,
                                params.message = "The field " + field + " of " + placeName + " was updated in the database";
                                params.result = updated;
                                succesfullCallback(params);
                        }
                });
        } else {
                params.response = false,
                params.state = 400,
                params.message = "The database is not initialiate";
                errorCallback(params);
        }
};

/**
 * @public This method update a field of a places in the database.
 * @param {String} placeID - The id of the place.
 * @param {Object} field - The object of branch that will be added.
 * @param {Function} succesfullCallback - When the database can update the place(s).
 * @param {Function} errorCallback - When the database cannot update the place(s).
**/
var addBranchToPlace = function(placeID, branch, succesfullCallback, errorCallback){

        var params = {};
        var updatedObject = {};
        if(isConnected) {
                branchesCollection.insert(branch, function(err, inserted) {
                        placesCollection.update(
                        {_id:placeID}, //query
                        {$push:{branch:inserted[0]._id}}, //Update
                        false, //Upsert
                        function(err, updated) {
                        if (err) {
                                params.response = false,
                                params.state = 400,
                                params.message = err;
                                errorCallback(params);
                        } else {
                                params.response = true,
                                params.state = 200,
                                params.message = "The branch " + branch + " of " + 
                                        placeID + " was add in the database";
                                params.result = inserted;
                                succesfullCallback(params);
                        }
                        branchesCollection.ensureIndex({location: '2d'}, function(err, doc) {
                                console.log(err);
                                console.log(doc);
                        });
                });
                });
        } else {
                params.response = false,
                params.state = 400,
                params.message = "The database is not initialiate";
                errorCallback(params);
        }
};

/**
 * @public This method update a field of a places in the database.
 * @param {String} placeName - The placeName of the place.
 * @param {String} field - The name of the field to be updated.
 * @param {Array, String, Object, Number} Value - The parameters to be edited/added.
 * @param {Function} succesfullCallback - When the database can update the place(s).
 * @param {Function} errorCallback - When the database cannot update the place(s).
**/
var updateFieldOfBranch = function(placeID, field, value, succesfullCallback, errorCallback){

        var params = {};
        var updatedObject = {};
        if(isConnected) {
                updatedObject[field] = value;
                branchesCollection.update(
                        {_id:placeID}, //query
                        {$set:updatedObject}, //Update
                        false, //Upsert
                        function(err, updated) {
                        if (err) {
                                params.response = false,
                                params.state = 400,
                                params.message = err;
                                errorCallback(params);
                        } else {
                                params.response = true,
                                params.state = 200,
                                params.message = "The field " + field + " of " + placeID + " was updated in the database";
                                params.result = updated;
                                succesfullCallback(params);
                        }
                });
        } else {
                params.response = false,
                params.state = 400,
                params.message = "The database is not initialiate";
                errorCallback(params);
        }
};

/**
 * @public This method find branch in the database.
 * @param {String} field - A name of the field to find.
 * @param {String} content - An Array of Strings who has the content to find.
 * @param {Array} filters - An Array of Strings who has the fields to get, if send the array 
                                empty get all the fields of documents.
 * @param {Function} succesfullCallback - When the database have found the branch.
 * @param {Function} errorCallback - When the database have not found the branch.
**/
var findBranch = function(field, content, filters, succesfullCallback, errorCallback){

        var contents = [content];
        findBranches(field, contents, filters, succesfullCallback, errorCallback);
};

/**
 * @public This method find branches in the database.
 * @param {String} field - A name of the field to find.
 * @param {Array} contents - An Array of Strings who has the content to find.
 * @param {Array} filters - An Array of Strings who has the fields to get, if send the array 
                                empty get all the fields of documents.
 * @param {Function} succesfullCallback - When the database have found the branches.
 * @param {Function} errorCallback - When the database have not found the branches.
**/
var findBranches = function(field, contents, filters, succesfullCallback, errorCallback){

        var params = {},
                query = {},
                fieldsFilters = {},
                isId = false;

        if(field.indexOf('_id') !== -1) {
                isId = true;
                for(var i in contents) {
                        contents[i] = new ObjectID(contents[i]);
                }
        }
        query[field] = {$in:contents};
        fieldsFilters = filters.length !== 0 ? {fields:filters} : {};

        if(isConnected) {
                branchesCollection.find(query, fieldsFilters).toArray(function(err, docs){
                        if(err) {
                                params.response = false,
                                params.state = 400,
                                params.message = err;
                                errorCallback(params);
                        } else {
                                params.response = true,
                                params.state = 200;
                                if (docs.length === 0) {
                                        params.state = 300;
                                        params.message = "The branch was not found";
                                        params.branch = docs[0];
                                } else if(docs.length < 2) {
                                        params.message = "The branch was found";
                                        params.branch = docs[0];
                                } else {
                                        params.message = "The branches was found";
                                        params.branches = docs;
                                }
                                succesfullCallback(params);
                        }
                });
        } else {
                params.response = false,
                params.state = 400,
                params.message = "The database is not initialiate";
                errorCallback(params);
        }
};

/**
 * @public This method find branches by location
 * @param {Integer} longitude - the longitude of point which is the user
 * @param {Integer} latitude - the latitude of the point which is the user
 * @param {Function} succesfullCallback - When the database can make the query.
 * @param {Function} errorCallback - When the database cannot make the query.
**/
var findBranchesByLocation = function(longitude, latitude, maxDistance, succesfullCallback, errorCallback) {
        var query = {'location.point':{$near: { $geometry :
                                { type : "Point" ,
                                  coordinates : [longitude, latitude]}}, $maxDistance:maxDistance}};
        var params = {};
        console.log(query);
        if(isConnected) {
                branchesCollection.ensureIndex({'location.point': '2d'}, function(err, doc) {
                        branchesCollection.find(query).toArray(function(err, docs){
                                if(err) {
                                        params.response = false,
                                        params.state = 400,
                                        params.message = err;
                                        errorCallback(params);
                                } else {
                                        params.response = true,
                                        params.state = 200;
                                        if (docs.length === 0) {
                                                params.state = 300;
                                                params.message = "The branch was not found";
                                                params.branch = docs[0];
                                        } else if(docs.length < 2) {
                                                params.message = "The branch was found";
                                                params.branch = docs;
                                        } else {
                                                params.message = "The branches was found";
                                                params.branch = docs;
                                        }
                                        succesfullCallback(params);
                                }
                        });
                });
        } else {
                params.response = false,
                params.state = 400,
                params.message = "The database is not initialiate";
                errorCallback(params);
        }   
};

/**
 * @public This method creates one CheckIn in the database
 * @param {Object} CheckIn - The name of the CheckIn.
 * @param {Function} succesfullCallback - When the database can create the CheckIn.
 * @param {Function} errorCallback - When the database cannot create the CheckIn.
**/
var createCheckIn = function(checkIn, succesfullCallback, errorCallback){

        /* CHECKINS OBJECT
        var checkIns = {
                date:'13 de septiembre de 2013',
                placeID:'nu7b3bubbbu3',
                branchID:'njnjn7y737279u29829s',
                userID:'neduhe737hd73gd73ghd7',
                placeName:'elcorral',
                branchName:'colina',
                username:'dazuku',
                dishes:[
                        {
                                name:'Hamburguesa',
                                photo:'localhost/images/thumbnail.png',
                                comment:'Sabrosa!',
                                ranking:5
                        },
                        {
                                name:'Hamburguesa de pollo',
                                photo:'localhost/images/thumbnail.png',
                                comment:'Sabrosa!',
                                ranking:5
                        }
                ],
                comment:'hello world',
                photo:'/img/checkIn.png'
        };
        CHECKINS OBJECT */

        var params = {};

        if(isConnected){
                if(checkIn.hasOwnProperty('date') && checkIn.hasOwnProperty('placeName') && checkIn.hasOwnProperty('branchName') && checkIn.hasOwnProperty('username')) {
                        checkInsCollection.insert(checkIn, function(err, inserted) {
                                if (err) {
                                        params.response = false,
                                        params.state = 400,
                                        params.message = err;
                                        errorCallback(params);
                                } else {
                                        params.response = true,
                                        params.state = 200,
                                        params.message = "The Check-In was created in the database";
                                        params.result = inserted;
                                        succesfullCallback(params);
                                }
                        });
                } else {
                        params.response = false,
                        params.state = 400,
                        params.message = "The Check-In object has no required fields";
                        errorCallback(params);
                }
        } else {
                params.response = false,
                params.state = 400,
                params.message = "The database is not initialiate";
                errorCallback(params);
        }
};

/**
 * @public This method find checkIns in the database.
 * @param {String} field - A name of the field to find.
 * @param {String} content - A String who has the content to find.
 * @param {Array} filters - An Array of Strings who has the fields to get, if send the array 
                                empty get all the fields of documents.
 * @param {Function} succesfullCallback - When the database have found the checkIns.
 * @param {Function} errorCallback - When the database have not found the checkIns.
**/
var findCheckIn = function(field, content, filters, succesfullCallback, errorCallback){

        var contents = [content];
        findCheckIns(field, contents, filters, succesfullCallback, errorCallback);
};

/**
 * @public This method find checkIns in the database.
 * @param {String} field - A name of the field to find.
 * @param {Array} content - An Array of Strings who has the content to find.
 * @param {Array} filters - An Array of Strings who has the fields to get, if send the array 
                                empty get all the fields of documents.
 * @param {Function} succesfullCallback - When the database have found the checkIns.
 * @param {Function} errorCallback - When the database have not found the checkIns.
**/
var findCheckIns = function(field, contents, filters, succesfullCallback, errorCallback){

        var params = {},
                query = {},
                fieldsFilters = {},
                isId = false;

        if(field === '_id') {
                isId = true;
                for(var i in contents) {
                        contents[i] = new ObjectID(contents[i]);
                }
        }
        query[field] = {$in:contents};
        fieldsFilters = filters.length !== 0 ? {fields:filters} : {};
        if(isConnected) {
                checkInsCollection.find(query, fieldsFilters).toArray(function(err, docs){
                        if(err) {
                                params.response = false,
                                params.state = 400,
                                params.message = err,
                                params.query = {query:query, fieldsFilters:fieldsFilters};
                                errorCallback(params);
                        } else {
                                params.response = true,
                                params.state = 200;
                                if (docs.length === 0) {
                                        params.state = 300;
                                        params.message = "The checkIn was not found";
                                        params.checkIn = docs[0];
                                } else if(docs.length < 2) {
                                        params.message = "The checkIn was found";
                                        params.checkIn = docs[0];
                                } else {
                                        params.message = "The checkIns was found";
                                        params.checkIns = docs;
                                }
                                succesfullCallback(params);
                        }
                });
        } else {
                params.response = false,
                params.state = 400,
                params.message = "The database is not initialiate";
                errorCallback(params);
        }
};

/**
 * @public This method delete a checkIns in the database.
 * @param {Array} ids - An Array of Strings who has the ids. 
 * @param {Function} succesfullCallback - When the database can delete the checkIns.
 * @param {Function} errorCallback - When the database cannot delete the checkIns.
**/
var deleteCheckIns = function(ids, succesfullCallback, errorCallback){

        var param = {};
        var idsQuery = [];

        if(isConnected) {
                findCheckIns(
                        '_id',
                        ids,
                        [],
                        function(params) {
                                var query = {};
                                if (params.hasOwnProperty('checkIn')) {
                                        if(typeof params.checkIn !== 'undefined') {
                                                query = {'_id': params.checkIn['_id']};
                                                checkInsCollection.remove(query);   
                                        } else {
                                                params.response = false,
                                                params.state = 400,
                                                params.message = "The checkIn is not found";
                                                errorCallback(params);
                                                return;   
                                        }
                                } else if(params.hasOwnProperty('checkIns')) {
                                        for (var i in params.checkIns) {
                                                query = {'_id': params.checkIn['_id']};
                                                checkInsCollection.remove(query);
                                        }
                                }
                                param.response = true,
                                param.state = 200;
                                param.message = "The checkIn(s) was removed for database";
                                param.result = params.result;
                                succesfullCallback(param);
                        },
                        function(params) {
                                errorCallback(params);
                        });
        } else {
                params.response = false,
                params.state = 400,
                params.message = "The database is not initialiate";
                errorCallback(params);
        }
};

/**
 * @public This method delete a checkIns in the database.
 * @param {String} id - The id of the checkIn.
 * @param {Function} succesfullCallback - When the database can delete the checkIn(s).
 * @param {Function} errorCallback - When the database cannot delete the checkIn(s).
**/
var deleteCheckIn = function(id, succesfullCallback, errorCallback){

        var ids = [id];
        deleteCheckIns(ids, succesfullCallback, errorCallback);
};
/**
 * @public This method delete a checkIn in the database.
 * @param {Array} placeNames - An Array of Strings who has the placeNames. 
 * @param {Function} succesfullCallback - When the database can delete the checkIn.
 * @param {Function} errorCallback - When the database cannot delete the checkIn.
**/
/* LOOK AT LATER
var deleteCheckIns = function(id, succesfullCallback, errorCallback){

        var param = {};

        if(isConnected) {
                findCheckIns(
                        '_id',
                        id,
                        [],
                        function(params) {
                                var query = {};
                                if (params.hasOwnProperty('checkIn')) {
                                        query = {_id: new ObjectID(params.checkIn._id)};
                                        checkInsCollection.remove(query);
                                } else if(params.hasOwnProperty('checkIns')) {
                                        for (var i in place) {
                                                query = {_id: new ObjectID(params.checkIns[i]._id)};
                                                checkInsCollection.remove(query);
                                        }
                                }
                                param.response = true,
                                param.state = 200;
                                param.message = "The checkIn(s) was removed for database";
                                param.result = params.result;
                                succesfullCallback(param);
                        },
                        function(params) {
                                errorCallback(params);
                        });
        } else {
                params.response = false,
                params.state = 400,
                params.message = "The database is not initialiate";
                errorCallback(params);
        }
};
LOOK AT LATER */
/**
 * @public This method delete a checkIns in the database.
 * @param {String} id - The id of the checkIn.
 * @param {Function} succesfullCallback - When the database can delete the checkIn(s).
 * @param {Function} errorCallback - When the database cannot delete the checkIn(s).
**/
/* LOOK AT LATER
var deleteCheckIn = function(id, succesfullCallback, errorCallback){

        var ids = [id];
        deleteCheckIns(ids, succesfullCallback, errorCallback);
};
LOOK AT LATER */


// Users
exports.createUser = createUser;
exports.findUser = findUser;
exports.findUsers = findUsers;
exports.deleteUsers = deleteUsers;
exports.deleteUser = deleteUser;
exports.updateUser = updateUser;
exports.updateFieldOfUser = updateFieldOfUser;
exports.updatePreferences = updatePreferences;
exports.updateUsername = updateUsername;
exports.updatePassword = updatePassword;
exports.updateMail = updateMail;
exports.updateLocation = updateLocation;
exports.updateGender = updateGender;
exports.updateDescription = updateDescription;
exports.updateTypeUser = updateTypeUser;

// Places
exports.createPlace = createPlace;
exports.findPlace = findPlace;
exports.findPlaces = findPlaces;
exports.findPlacesWithRegex = findPlacesWithRegex;
exports.deletePlaces = deletePlaces;
exports.deletePlace = deletePlace;
exports.updatePlace = updatePlace;
exports.updateFieldOfPlace = updateFieldOfPlace;
exports.addBranchToPlace = addBranchToPlace;
exports.findBranch = findBranch;
exports.findBranches = findBranches;
exports.updateFieldOfBranch = updateFieldOfBranch;
exports.findBranchesByLocation = findBranchesByLocation;

// CheckIns
exports.createCheckIn = createCheckIn;
exports.findCheckIn = findCheckIn;
exports.findCheckIns = findCheckIns;
exports.deleteCheckIns = deleteCheckIns;
exports.deleteCheckIn = deleteCheckIn;