var  databaseManager  =  require ( './databaseManager' );

// Find place ?? find branch
// Rank Dish add find dish
//FMFServer.post('/places/:placeName/:dishID',somethingHere());

/**
*@private Validates the required attributes of branch object in (createbranch).
*@param {object} branch - Required for make the validation of branch attributes.
*@requires branch fields: placeName, branchName, location.
*@returns boolean.
**/

var validateBranch = function(branch){
        var branchFromCLient = branch;
        if(branchFromCLient.hasOwnProperty('placeName') && branchFromCLient.hasOwnProperty('branchName') && branchFromCLient.hasOwnProperty('location')){
            if(branchFromCLient.placeName.length > 0 && branchFromCLient.branchName.length > 0 && branchFromCLient.location.hasOwnProperty('point')&& branchFromCLient.location.point.hasOwnProperty('lat')&& branchFromCLient.location.point.hasOwnProperty('lng')){
                    return(true);
                }else{
                    return(false);
                }
        }else{
                return(false);
        }
};

/**
*@private Validates the required attributes of place in (createplace)
*@param {object} place - Required for make the validation of place attributes.
*@returns boolean
*@requires place fields: placeName.
**/

var validatePlace = function(place){
        var placeFromCLient = place;
        if(placeFromCLient.hasOwnProperty('placeName')){
                if(placeFromCLient.placeName.length > 0){
                        return(true);
                }else{
                        return(false);
                }
        }else{
                return(false);
        }
};

/**
*@public This method is a express callback that validates the place in dbs and register the place if is new
*@param {readable node.js stream} request - Arrive with a place {object}
*@param {writable node.js stream} response - Return a status, msg, menssaje, and place{object} 
**/

var createPlace = function(req, res){
        var placeFromClient = req.body,
        responseToClient = {};
        if(validatePlace(placeFromClient)){
            databaseManager.findPlace("placeName",
                placeFromClient.placeName,[],
                function(data){
                        if(typeof data.place == "undefined"){
                            databaseManager.createPlace(placeFromClient,
                                function(data){
                                    if(data.state == 200){
                                        responseToClient.meta = {"status":200,"msg":"ok"};
                                        responseToClient.response = data.result;
                                        res.send(responseToClient);
                                    }else{
                                        responseToClient.meta = {"status":400,"msg":"err"};
                                        responseToClient.response = {message:"failed creation of the place"};
                                        res.send(responseToClient);
                                    }
                                },
                            function(params){
                                res.send(params);});
                        }else{
                            responseToClient.meta = {"status":400,"msg":"err"};
                            responseToClient.response = {message:"The place already exist"};
                            res.send(responseToClient);
                        }
                },
                function(params){
                    res.send(params);});
        }else{
            responseToClient.meta = {"status":400,"msg":"err"};
            responseToClient.response = {message:"Complete the required fields"};//especificar cuales campos
            res.send(responseToClient);
        }
};

/**
*@public This method is a express callback that update the place in dbs if have a change new
*@param {readable node.js stream} request - Arrive with a update {object}
*@param {writable node.js stream} response - Return a status, msg, menssaje, and place{object} 
**/

var updatePlace = function(req, res){
        res.send("method in process");
};

/**
*@public This method is a express callback that validates the branch in dbs and register the branch if is new
*@param {readable node.js stream} request - Arrive with a branch {object}
*@param {writable node.js stream} response - Return a status, msg, menssaje, and branch{object} 
**/

var createBranch = function(req, res){
    var branchFromCLient = req.body,
    responseToClient = {};
    if(validateBranch(branchFromCLient)){
        databaseManager.findBranch("branchName",
            branchFromCLient.branchName,[],
            function(data){
                    if(typeof data.place == "undefined"){
                            databaseManager.addBranchToPlace(branchFromCLient.placeName, branchFromCLient,
                                function(data){
                                    if(data.state == 200){
                                        responseToClient.meta = {"status":200,"msg":"ok"};
                                        responseToClient.response = {"message":"Added branch", "branch":data.result};
                                        res.send(responseToClient);
                                    }else{
                                        responseToClient.meta = {"status":400,"msg":"err"};
                                        responseToClient.response = {message:"failed creation of the branch"};
                                        res.send(responseToClient);
                                    }
                                },
                            function(data){console.log(data);});
                    }else{
                        responseToClient.meta = {"status":400,"msg":"err"};
                        responseToClient.response = {message:"The branch is already exist"};
                        res.send(responseToClient);
                    }
            },function(){});
    }else{
        responseToClient.meta = {"status":400,"msg":"err"};
        responseToClient.response = {message:"Complete the required fields"};//especificar cuales campos
        res.send(responseToClient);
    }
};

/**
*@public This method is a express callback that update the branch in dbs if have a change new
*@param {readable node.js stream} request - Arrive with a update {object}
*@param {writable node.js stream} response - Return a status, msg, menssaje, and branch{object} 
**/

var updateBranch = function(req, res){
        res.send("method in process");
};


/**
*@public This method is a express callback tto get the branches by location in dbs
*@param {readable node.js stream} request - Arrive with a longitude, latitude and maxDistance {object}
*@param {writable node.js stream} response - Return a status, msg, menssaje, and branch {object} 
**/
var getBranchesByLocation = function(req, res) {
    var branchesByLocation = req.params,
    responseToClient={};
    if(branchesByLocation.hasOwnProperty('longitude') && branchesByLocation.hasOwnProperty('latitude') && branchesByLocation.hasOwnProperty('maxDistance')) {
        databaseManager.findBranchesByLocation(branchesByLocation.longitude, branchesByLocation.latitude, branchesByLocation.maxDistance,
            function(data) {
                if(data.state == 200){
                    responseToClient.meta = {"status":200,"msg":"ok"};
                    responseToClient.response = data.branch;
                    res.send(responseToClient);
                }else{
                    responseToClient.meta = {"status":400,"msg":"err"};
                    responseToClient.response = {message:"branches not found"};
                    res.send(responseToClient);
                }
            },
            function(data) {
                responseToClient.meta = {"status":400,"msg":"err"};
                responseToClient.response = {message:data};
                res.send(responseToClient);
            });
    } else {
        responseToClient.meta = {"status":400,"msg":"err"};
        responseToClient.response = {message:"Complete the required field"};
        res.send(responseToClient);
    }
};
/**
*@public This method is a express callback that qualifies the place, and send data to dbs
*@param {readable node.js stream} request - Arrive with a rank{object}
*@param {writable node.js stream} response - Return a status, msg, menssaje, and rank{object} 
*@requires rank fields: placeName, ranking.
**/
var rankPlace = function(req,res){
    var rankFromClient = req.body,
    responseToClient;
    if(rankFromClient.hasOwnProperty("placeName") && rankFromClient.hasOwnProperty("ranking")){
        if(typeof rankFromClient.ranking == "number"){
          res.send("Validate rank sucessful");
        }else{
            res.send("error value");
        }
    }else{
        res.send("Validate ranking error");
    }
};

/**
*@public This method is a express callback that find all places by name in dbs
*@param {readable node.js stream} request - Arrive with a find{object}
*@param {writable node.js stream} response - Return a status, msg, menssaje, and places{object} 
*@requires find fields: placeName.
**/
//////////-------------- findplace no sirve en este caso usar nueva busqueda creada por daniel (regex)-----------//////////
var findPlacesListByName = function(req,res){
   var placeFromClient = req.body,
    responseToClient = {};
        if(validatePlace(placeFromCLient)){
            databaseManager.findPlace("placeName",
                placeFromClient.placeName,[],
                function(data){
                    if(data.state == 200){
                        responseToClient.meta = {"status":200,"msg":"ok"};
                        responseToClient.response = data.places;
                        res.send(responseToClient);
                    }else{
                        responseToClient.meta = {"status":400,"msg":"err"};
                        responseToClient.response = {message:"places not found"};
                        res.send(responseToClient);
                    }
                },
                function(data){res.send(data);});
        }else{
            responseToClient.meta = {"status":400,"msg":"err"};
            responseToClient.response = {message:"Complete the required field"};
            res.send(responseToClient);
        }
};

/**
*@public This method is a express callback that find place by place Id in dbs
*@param {readable node.js stream} request - Arrive with a findById{object}
*@param {writable node.js stream} response - Return a status, msg, menssaje, and place{object} 
*@requires findById fields: _id.
**/

var getDataByPlaceId = function(req,res){
   var placeFromClient = req.params,
    responseToClient = {};
        if(placeFromClient.hasOwnProperty("_id")){
            databaseManager.findPlace("_id",
                placeFromClient._id,[],
                function(data){
                    if(data.state == 200){
                        responseToClient.meta = {"status":200,"msg":"ok"};
                        responseToClient.response = data.place;
                        res.send(responseToClient);
                    }else{
                        responseToClient.meta = {"status":400,"msg":"err"};
                        responseToClient.response = {message:"places not found"};
                        res.send(responseToClient);
                    }
                },
                function(data){res.send(data);});
        }else{
            responseToClient.meta = {"status":400,"msg":"err"};
            responseToClient.response = {message:"Complete the required field"};
            res.send(responseToClient);
        }
};

/**
*@public This method is a express callback that find branch by Id in dbs
*@param {readable node.js stream} request - Arrive with a findById{object}
*@param {writable node.js stream} response - Return a status, msg, menssaje, and branch{object} 
*@requires findById fields: _id.
**/

/////////////////////--------REVISAR FIND----------///////////////////
var getDataByBranchId = function(req,res){
   var placeFromClient = req.params,
    responseToClient = {};
    console.log(placeFromClient);
        if(placeFromClient.hasOwnProperty("_id")){
            databaseManager.findBranch("_id",
                placeFromClient._id,[],
                function(data){
                    if(data.state == 200){
                        responseToClient.meta = {"status":200,"msg":"ok"};
                        responseToClient.response = data.branch;
                        res.send(responseToClient);
                    }else{
                        responseToClient.meta = {"status":400,"msg":"err"};
                        responseToClient.response = {message:"branch not found"};
                        res.send(responseToClient);
                    }
                },
                function(data){res.send(data);});
        }else{
            responseToClient.meta = {"status":400,"msg":"err"};
            responseToClient.response = {message:"Complete the required field"};
            res.send(responseToClient);
        }
};

/**
*@public This method is a express callback that validates the dish in dbs and create the dish if is new
*@param {readable node.js stream} request - Arrive with a dish{object}
*@param {writable node.js stream} response - Return a status, msg, menssaje, and dish{object} 
**/

var createDish = function(req,res){
        res.send("method in process");
};

/**
*@public This method is a express callback that find dish by Id in dbs
*@param {readable node.js stream} request - Arrive with a dishId{object}
*@param {writable node.js stream} response - Return a status, msg, menssaje, and dish{object} 
**/

var findDish = function(req,res){
        res.send("method in process");
};

/**
*@public This method is a express callback that qualifies the dish, and send data to dbs
*@param {readable node.js stream} request - Arrive with a rank{object}
*@param {writable node.js stream} response - Return a status, msg, menssaje, and rank{object} 
**/

var rankDish = function(req,res){
        res.send("method in process");
};

/**
*@public This method is a express callback that deleted a dish in dbs
*@param {readable node.js stream} request - Arrive with a delete{object}
*@param {writable node.js stream} response - Return a status, msg, menssaje.
**/

var deleteDish = function(req,res){
        res.send("method in process");
};

/**
*@public This method is a express callback that deleted a place in dbs
*@param {readable node.js stream} request - Arrive with a delete{object}
*@param {writable node.js stream} response - Return a status, msg, menssaje.
**/

var deletePlace = function(req,res){
        res.send("method in process");
};

/**
*@public This method is a express callback that deleted a branch in dbs
*@param {readable node.js stream} request - Arrive with a delete{object}
*@param {writable node.js stream} response - Return a status, msg, menssaje.
**/

var deleteBranch = function(req,res){
        res.send("method in process");
};


var findBranchByLocation = function(req, res) {

}

var findPlace = function(req, res) {
    var content = req.params.content,
        field = req.params.field;
            
    databaseManager.findPlacesWithRegex(field, content, [], 
        function(data) {
            if(data.state == 200){
                responseToClient.meta = {"status":200,"msg":"ok"};
                responseToClient.response = data.place;
                res.send(responseToClient);
            }else{
                responseToClient.meta = {"status":400,"msg":"err"};
                responseToClient.response = {message:"places not found"};
                res.send(responseToClient);
            }
        },
        function(data) {
            res.send(data);
        });
}

exports.createPlace = createPlace;
exports.updatePlace = updatePlace;
exports.deletePlace = deletePlace;
exports.createBranch = createBranch;
exports.updateBranch = updateBranch;
exports.deleteBranch = deleteBranch;
exports.rankPlace = rankPlace;
exports.createDish = createDish;
exports.deleteDish = deleteDish;
exports.findDish = findDish;
exports.rankDish = rankDish;
exports.findPlace = findPlace;
exports.getDataByPlaceId = getDataByPlaceId;
exports.getDataByBranchId = getDataByBranchId;
exports.getBranchesByLocation = getBranchesByLocation;
//exports.updateFieldOfPlace = updateFieldOfPlace;
