var  databaseManager  =  require ( './databaseManager' );
//var crypto = require('crypto'),
//shasum = crypto.createHash('sha256');

/**
*@public This method is a express callback that find user by user Id in dbs
*@param {readable node.js stream} request - Arrive with a findById{object}
*@param {writable node.js stream} response - Return a status, msg, menssaje, and user{object} 
*@requires findById fields: _id.
**/

var findUserById = function(req, res) {
	var userFromClient = req.params,
    responseToClient = {};
        if(userFromClient.hasOwnProperty("_id")){
            databaseManager.findUser("_id",
                userFromClient._id,[],
                function(data){
                    if(data.state == 200){
                        responseToClient.meta = {"status":200,"msg":"ok"};
                        responseToClient.response = data.user;
                        res.send(responseToClient);
                    }else{
                        responseToClient.meta = {"status":400,"msg":"err"};
                        responseToClient.response = {message:"User not found"};
                        res.send(responseToClient);
                    }
                },
                function(data){res.send(data);});
        }else{
            responseToClient.meta = {"status":400,"msg":"err"};
            responseToClient.response = {message:"Complete the required field"};
            res.send(responseToClient);
        }
};

/**
*@public This method is a express callback that find user by username in dbs
*@param {readable node.js stream} request - Arrive with a find{object}
*@param {writable node.js stream} response - Return a status, msg, menssaje, and user{object} 
*@requires find fields: username.
**/

var findUserByUsername = function(req, res) {
	var userFromClient = req.params,
    responseToClient = {};
        if(userFromClient.hasOwnProperty("username")){
            databaseManager.findUser("username",
                userFromClient.username,[],
                function(data){
                    if(data.state == 200){
                        responseToClient.meta = {"status":200,"msg":"ok"};
                        responseToClient.response = data.user;
                        res.send(responseToClient);
                    }else{
                        responseToClient.meta = {"status":400,"msg":"err"};
                        responseToClient.response = {message:"User not found"};
                        res.send(responseToClient);
                    }
                },
                function(data){res.send(data);});
        }else{
            responseToClient.meta = {"status":400,"msg":"err"};
            responseToClient.response = {message:"Complete the required field"};
            res.send(responseToClient);
        }
};

/**
*@public this method is a express callback  that validates the user in dbs and register the user if is new
*@param request {readable node.js stream} - Arrive with a user {object}
*@param {writable node.js stream} response - Return a status, msg, menssaje, and user{object} 
**/

var createUser = function(req, res) {

	var userFromClient = req.body,
	responseToClient = {};
	if(validateUser(userFromClient)){
		databaseManager.findUser("username",
			userFromClient.username,[],
			function(data){
				if(typeof data.user === "undefined"){
					databaseManager.findUser("email",
						userFromClient.email,[],
						function(data){
							if(typeof data.user ==="undefined"){
								//shasum.update(userFromClient.password);
								//userFromClient.password = shasum.digest('binary');
								databaseManager.createUser(userFromClient,
									function(data){
										if(data.state==200){
											responseToClient.meta = {"status":200,"msg":"ok"};
											responseToClient.response = data.result/*quitar el pass*/;
											res.send(responseToClient);
										}else{
											responseToClient.meta = {"status":400,"msg":"err"};
											responseToClient.response = {"message":"registration failed"};
											res.send(responseToClient);
										}
									},
								function(){});
							}else{
								responseToClient.meta = {"status":400,"msg":"err"};
								responseToClient.response =  {"message":"The user is already registered"};
								res.send(responseToClient);
							}
						},function(){});
				}else{
					responseToClient.meta = {"status":400,"msg":"err"};
					responseToClient.response =  {"message":"The user is already registered"};
					res.send(responseToClient);
				}
			},function(){});
	}else{
		responseToClient.meta = {"status":400,"msg":"err"};
		responseToClient.response = {"message":"Complete the required fields"};//especificar cuales campos
		res.send(responseToClient);
	}
};

/**
*@private Validates the required attributes of user in (createUser)
*@param {object} user - Required for make the validation of user attributes.
*@returns boolean
*@requires place fields: username, password, location, email, birthday, gender.
**/

var validateUser = function(user){
	var userFromClient = user;
	if(userFromClient.hasOwnProperty('username') && userFromClient.hasOwnProperty('password') && userFromClient.hasOwnProperty('location') && userFromClient.hasOwnProperty('email') && userFromClient.hasOwnProperty('birthday') && userFromClient.hasOwnProperty('gender')){
		if(userFromClient.username.length > 0 && userFromClient.password.length > 0  && userFromClient.location.hasOwnProperty('long') && userFromClient.location.hasOwnProperty('lat') && userFromClient.email.length > 0 && userFromClient.birthday.length > 0 && userFromClient.gender.length > 0){
			return(true);
		}else{
			return(false);
		}
	}else{
		return(false);
	}
};

/**
*@private Validates the required attributes of user in (loginUser)
*@param {object} user - Required for make the validation of user attributes.
*@returns boolean
*@requires place fields: username, password.
**/

var validateUserLogin = function(user){
	var userFromClient = user;
	if(userFromClient.hasOwnProperty('username') && userFromClient.hasOwnProperty('password')){
	//console.log("the object dont have conflict");
		if(userFromClient.username.length > 0 && userFromClient.password.length > 0){
			return(true);
		}else{
			return(false);
		}
	} else if(userFromClient.hasOwnProperty('email') && userFromClient.hasOwnProperty('password')){
		if(userFromClient.email.length > 0 && userFromClient.password.length > 0){
			return(true);
		}else{
			return(false);
		}
	}else{
		return(false);
	}
};

/**
*@public this method is a express callback  that validates the user in dbs and login if was registered
*@param request {readable node.js stream} - Arrive with a user {object}
*@param response {writable node.js stream} - Return a menssaje, code and user {object} 
**/

var loginUser = function(req, res){
	var userFromClient = req.body,
	responseToClient = {};
	if(validateUserLogin(userFromClient)){
		//shasum.update(userFromClient.password);
		//userFromClient.password = shasum.digest('binary');
		databaseManager.findUser("username",
			userFromClient.username,[],
			function(data){
				if(typeof data.user === "undefined"){
					databaseManager.findUser("email",
						userFromClient.email,[],
						function(data){
							if(typeof data.user === "undefined"){
								responseToClient.meta = {"status":400,"msg":"err"};
								responseToClient.response = {"message":"User Not Found"};
								res.send(responseToClient);
							}else{
								if(data.user.password === userFromClient.password){
									responseToClient.meta = {"status":200,"msg":"ok"};
									responseToClient.response = {"message":"login successful", "user":data.user};
									res.send(responseToClient);
								}else{
									responseToClient.meta = {"status":400,"msg":"err"};
									responseToClient.response = {"message":"password incorrect"};
									res.send(responseToClient);
								}
							}
						},
						function(){});
				}else{
					if(data.user.password === userFromClient.password){
						responseToClient.meta = {"status":200,"msg":"ok"};
						responseToClient.response = {"message":"login successful", "user":data.user};
						res.send(responseToClient);
					}else{
						responseToClient.meta = {"status":400,"msg":"err"};
						responseToClient.response = {"message":"password incorrect"};
						res.send(responseToClient);
					}
				}
			},
			function(){});
	}else{
		responseToClient.meta = {"status":400,"msg":"err"};
		responseToClient.response = {"message":"Complete the required fields"};//especificar cuales campos
		res.send(responseToClient);
	}
};

/**
*@public This method is a express callback that update user in dbs if have a change new
*@param {readable node.js stream} request - Arrive with a update {object}
*@param {writable node.js stream} response - Return a status, msg, menssaje, and user{object} 
**/

var updateUser = function(req, res) {
	var updateFromClient = req.body,
	responseToClient = {};

	//update Preferences

	if(updateFromClient.hasOwnProperty('username') && updateFromClient.username.length > 0 && updateFromClient.hasOwnProperty('preferences')){
		databaseManager.updatePreferences(updateFromClient.username,updateFromClient.preferences,
			function(data){
				if(data.state == 200){
					responseToClient.meta = {"status":200,"msg":"ok"};
					responseToClient.response = {"message":"Update Preferences successful", "user":data.result};//data.result , viene el user?
					res.send(responseToClient);
				}else{
					responseToClient.meta = {"status":400,"msg":"err"};
					responseToClient.response = {"message":"Update Preferences failed"};
					res.send(responseToClient);
				}
			},
		function(data){res.send(data);});
	//databaseManager.findUser("username",updateFromClient.username,[],function(data){console.log(data);},function(){});
	}

	//Update Email

	if(updateFromClient.hasOwnProperty('username') && updateFromClient.username.length > 0 && updateFromClient.hasOwnProperty('email') && updateFromClient.email.length > 0){
		databaseManager.updateMail(updateFromClient.username,updateFromClient.email,
			function(data){
				if(data.state == 200){
					responseToClient.meta = {"status":200,"msg":"ok"};
					responseToClient.response = {"message":"Update mail successful", "user":data.result};//data.result , viene el user?
					res.send(responseToClient);
				}else{
					responseToClient.meta = {"status":400,"msg":"err"};
					responseToClient.response = {"message":"Update mail failed"};
					res.send(responseToClient);
				}
			},
		function(){});
	//databaseManager.findUser("username",updateFromClient.username,[],function(data){console.log(data);},function(){});
	}

	//Update Gender

	if(updateFromClient.hasOwnProperty('username') && updateFromClient.username.length > 0 && updateFromClient.hasOwnProperty('gender') && updateFromClient.gender.length > 0){
		databaseManager.updateGender(updateFromClient.username,updateFromClient.gender,
			function(data){
				if(data.state == 200){
					responseToClient.meta = {"status":200,"msg":"ok"};
					responseToClient.response = {"message":"Update gender successful", "user":data.result};
					res.send(responseToClient);
				}else{
					responseToClient.meta = {"status":400,"msg":"err"};
					responseToClient.response = {"message":"Update gender failed"};
					res.send(responseToClient);
				}
			},
		function(){});
	//databaseManager.findUser("username",updateFromClient.username,[],function(data){console.log(data);},function(){});
	}

	//Update Password

	if(updateFromClient.hasOwnProperty('username') && updateFromClient.username.length > 0 && updateFromClient.hasOwnProperty('password') && updateFromClient.password.length > 0){
		databaseManager.updatePassword(updateFromClient.username,updateFromClient.password,
			function(data){
				if(data.state == 200){
					responseToClient.meta = {"status":200,"msg":"ok"};
					responseToClient.response = {"message":"Update password successful", "user":data.result};
					res.send(responseToClient);
				}else{
					responseToClient.meta = {"status":400,"msg":"err"};
					responseToClient.response = {"message":"Update password failed"};
					res.send(responseToClient);
				}
			},
		function(){});
	//databaseManager.findUser("username",updateFromClient.username,[],function(data){console.log(data);},function(){});
	}

	//Update Description

	if(updateFromClient.hasOwnProperty('username') && updateFromClient.username.length > 0 && updateFromClient.hasOwnProperty('description') && updateFromClient.description.length > 0){
		databaseManager.updateDescription(updateFromClient.username,updateFromClient.description,
			function(data){
				if(data.state == 200){
					responseToClient.meta = {"status":200,"msg":"ok"};
					responseToClient.response = {"message":"Update description successful", "user":data.result};
					res.send(responseToClient);
				}else{
					responseToClient.meta = {"status":400,"msg":"err"};
					responseToClient.response = {"message":"Update description failed"};
					res.send(responseToClient);
				}
			},
		function(){});
	//databaseManager.findUser("username",updateFromClient.username,[],function(data){console.log(data);},function(){});
	}

	//Update Location

	if(updateFromClient.hasOwnProperty('username') && updateFromClient.username.length > 0 && updateFromClient.hasOwnProperty('location')){
		if(updateFromClient.location.hasOwnProperty('long') && updateFromClient.location.hasOwnProperty('lat') && updateFromClient.location.long > 0 && updateFromClient.location.lat > 0){
			databaseManager.updateLocation(updateFromClient.username,updateFromClient.location,
				function(data){
					if(data.state == 200){
						responseToClient.meta = {"status":200,"msg":"ok"};
						responseToClient.response = {"message":"Update location successful", "user":data.result};
						res.send(responseToClient);
					}else{
						responseToClient.meta = {"status":400,"msg":"err"};
						responseToClient.response = {"message":"Update location failed"};
						res.send(responseToClient);
					}
				},
				function(){});
			//databaseManager.findUser("username",updateFromClient.username,[],function(data){console.log(data);},function(){});
		}
	}
};

/**
*@public This method is a express callback that deleted a user in dbs
*@param {readable node.js stream} request - Arrive with a delete{object}
*@param {writable node.js stream} response - Return a status, msg, menssaje.
**/

var deleteUser = function(req, res) {
	var userFromClient = req.params,
	responseToClient = {};
	if(validateUserLogin(userFromClient)){
		//shasum.update(userFromClient.password);
		//userFromClient.password = shasum.digest('binary');
		databaseManager.findUser("username",
			userFromClient.username,[],
			function(data){
				if(typeof data.user === "undefined"){
					databaseManager.findUser("email",
						userFromClient.email,[],
						function(data){
							if(typeof data.user === "undefined"){
								responseToClient.meta = {"status":400,"msg":"err"};
								responseToClient.response = {"message":"User not found"};
								res.send(responseToClient);
							}else{
								if(data.user.password === userFromClient.password){
									databaseManager.deleteUser(userFromClient.username,
										function(data){
											if(data.state == 200){
												responseToClient.meta = {"status":200,"msg":"ok"};
												responseToClient.response = {"message":"User deleted successful"};
												res.send(responseToClient);
											}else{
												responseToClient.meta = {"status":400,"msg":"err"};
												responseToClient.response = {"message":"Elimination failed"};
												res.send(responseToClient);
											}
										},
									function(){});
								}else{
									responseToClient.meta = {"status":400,"msg":"err"};
									responseToClient.response = {"message":"Password incorrect"};
									res.send(responseToClient);
								}
							}
						},
						function(){});
				}else{
					if(data.user.password === userFromClient.password){
						databaseManager.deleteUser(userFromClient.username,
							function(data){
								if(data.state == 200){
									responseToClient.meta = {"status":200,"msg":"ok"};
									responseToClient.response = {"message":"User deleted successful"};
									res.send(responseToClient);
								}else{
									responseToClient.meta = {"status":400,"msg":"err"};
									responseToClient.response = {"message":"Elimination failed"};
									res.send(responseToClient);
								}
							},
							function(){});
						}else{
							responseToClient.meta = {"status":400,"msg":"err"};
							responseToClient.response = {"message":"Password incorrect"};
							res.send(responseToClient);
						}
				}
			},
			function(){});
	}else{
		responseToClient.meta = {"status":400,"msg":"err"};
		responseToClient.response = {"message":"Complete the required fields"};//especificar cuales campos
		res.send(responseToClient);
	}
};

exports.findUserById = findUserById;
exports.findUserByUsername = findUserByUsername;
exports.createUser = createUser;
exports.updateUser = updateUser;
exports.deleteUser = deleteUser;
exports.validateUser = validateUser;
exports.validateUserLogin = validateUserLogin;
exports.loginUser = loginUser;